#
# spec file for package mod_python (Version 2.7.10)
#
# Copyright (c) 2005 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://www.suse.de/feedback/
#

# neededforbuild  apache-devel-packages db-devel python python-devel
# usedforbuild    aaa_base acl attr bash bind-utils bison bzip2 coreutils cpio cpp cvs cyrus-sasl db devs diffutils e2fsprogs file filesystem fillup findutils flex gawk gdbm-devel glibc glibc-devel glibc-locale gpm grep groff gzip info insserv kbd less libacl libattr libgcc libstdc++ libxcrypt m4 make man mktemp modutils ncurses ncurses-devel net-tools netcfg openldap2-client openssl pam pam-devel pam-modules patch permissions popt ps rcs readline sed sendmail shadow strace syslogd sysvinit tar texinfo timezone unzip util-linux vim zlib zlib-devel apache apache-devel autoconf automake binutils cracklib db-devel expat gcc gdbm gettext libtool mm mod_ssl perl python python-devel rpm

Name:         mod_python
%define apache_libexecdir %(apxs -q LIBEXECDIR)
%define apache_sysconfdir %(apxs -q SYSCONFDIR)
%define apache_includedir %(apxs -q INCLUDEDIR)
%define python_sitepath   %(/usr/bin/python -c 'import site; print site.sitedirs[0];')
%define apache_mmn        %(MMN=$(apxs -q LIBEXECDIR)/MMN; test -x $MMN && $MMN)
Version:      2.7.10
Release:      89
License:      FSR
Group:        Productivity/Networking/Web/Servers
%define pyver %(python -c 'import sys; print sys.version[:3]')
Requires:     apache %{apache_mmn} python >= %pyver, python < %{pyver}.99
Conflicts:    apache2-mod_python
PreReq:       %fillup_prereq
Autoreqprov:  on
Summary:      Python module for the Apache web server
URL:          http://www.modpython.org/
Icon:         %{name}.xpm
Source:       %{name}-%{version}.tar.bz2
Patch:        %{name}-2.7.6.dif
Patch1:       mod_python-2.7.10-publisher.dif

%description
Mod_python allows embedding Python within the Apache http server for a
considerable boost in performance and added flexibility in designing
web based applications.

Apache processes requests in stages (e.g. read the request, parse
headers, check access, etc.). These stages can be implemented by
functions called handlers. Traditionally, handlers are written in C and
compiled into Apache modules. Mod_python provides a way to extend
Apache functionality by writing Apache handlers in Python. For a
detailed description of the Apache request processing process, see the
Apache API Notes.

For most programmers, the request and the authentication handlers
provide everything required. To ease migration from CGI and Httpdapy,
two handlers are provided that simulate these environments allowing a
user to run his scripts under mod_python with (for the most part) no
changes to the code.

Mod_python originates from a project called Httpdapy. For a long time
Httpdapy was not called mod_python because Httpdapy was not meant to be
Apache-specific. Httpdapy was designed to be cross-platform and in fact
was initially written for the Netscape server.



Authors:
--------
    Gregory Trubetskoy <grisha@ispol.com>

%prep
%setup
%patch
%patch1 -p1
cp configure.in configure.in.old
sed 's@lib/python@%{_lib}/python@' < configure.in.old >  configure.in
rm -f configure.in.old

%build
rm -f config.cache
autoconf
export OPTFLAGS="`apxs -q CFLAGS` -Wall" 
%{configure}
#./configure --with-apxs=%{_sbindir}/apxs %{_target_cpu}-suse-linux 
make dso 

%install
export PATH=$PATH:%{apache_libexecdir}/bin
make install 
cat > apache.rc.config <<-EOF
	## Type:        yesno
	## Default:     "yes"
	## Config:      apache
	## ServiceRestart: apache
	#
	# enable the python module
	#
	HTTPD_SEC_MOD_PYTHON=yes
	
EOF
cat > %{apache_sysconfdir}/modules/%{name} <<-EOF
	Variable:HTTPD_SEC_MOD_PYTHON
	Text:Python
	LoadModule:LoadModule python_module %{apache_libexecdir}/mod_python.so
	AddModule:AddModule mod_python.c
EOF
install -m 644 apache.rc.config %{_var}/adm/fillup-templates/sysconfig.apache-%{name}
cat > %{apache_sysconfdir}/suse_loadmodule.conf <<-EOF
	LoadModule python_module %{apache_libexecdir}/mod_python.so 
EOF
cat > %{apache_sysconfdir}/suse_addmodule.conf <<-EOF
	AddModule mod_python.c
EOF
mkdir -p /usr/lib/python2.2/site-packages/
%{_sbindir}/httpd -t           || exit 1

%post
%{fillup_only -an apache}

%files
%defattr(644,root,root,755)
%doc COPYRIGHT CREDITS NEWS README doc-html Doc
%defattr(-,root,root)
%{python_sitepath}/mod_python
%{apache_libexecdir}/%{name}.so
%{apache_sysconfdir}/modules/%{name}
%{_var}/adm/fillup-templates/sysconfig.apache-%{name}

%changelog -n mod_python
* Fri Feb 11 2005 - poeml@suse.de
- fix CAN-2005-0088 patch [#50324]
* Tue Feb 01 2005 - poeml@suse.de
- fix information leak in publisher handler, CAN-2005-0088 [#50324]
* Wed Feb 11 2004 - poeml@suse.de
- update to 2.7.10, which fixes a vulnerability whereby a specific
  query string processed by mod_python would cause the httpd rocess
  to crash. [#34115]
* Fri Aug 29 2003 - mcihar@suse.cz
- require same python version as it was built with
* Fri Aug 29 2003 - poeml@suse.de
- Conflicts: apache2-mod_python [#29637]
* Thu Aug 14 2003 - poeml@suse.de
- add activation metadata to sysconfig template [#28828]
- RPM_OPT_FLAGS come from `apxs -q CFLAGS`
- use -Wall
* Sun Jul 27 2003 - poeml@suse.de
- don't explicitely strip binaries since RPM handles it, and may
  keep the stripped information somewhere
* Thu Jan 23 2003 - poeml@suse.de
- add sysconfig metadata (closes #22605)
* Fri Nov 29 2002 - mcihar@suse.cz
- using normal python as is seems that mod_python works correctly
  with python 2.2.2 and threads
- fixed building on lib64 arches
* Thu Aug 01 2002 - poeml@suse.de
- update to 2.7.8 which fixes the security issue whereby a module
  indirectly imported by a published module could then be accessed
  via the publisher.
- bzip2 sources
- work around mod_python searching in wrong path ("could not import
  mod_python.apache.") by a symbolic link
* Thu Aug 01 2002 - poeml@suse.de
- use PreReq
* Thu Jul 25 2002 - poeml@suse.de
- detect the module magic number if provided by apache, indicating
  API changes, and add an RPM Require on it
* Thu Jan 17 2002 - ro@suse.de
- adapted for /etc/sysconfig/apache
* Tue Dec 11 2001 - mmj@suse.de
- Update to 2.7.6
* Thu Oct 25 2001 - ro@suse.de
- try neededforbuild alias apache-devel-packages
* Tue Aug 07 2001 - kukuk@suse.de
- Don't include data over symlink twice
* Tue Jul 31 2001 - rolf@suse.de
- update to 2.7.5
- update to python 2.1
* Wed Mar 28 2001 - rolf@suse.de
- update to 2.7.2
- add Apache module file for SuSEconfig
* Fri Feb 23 2001 - ro@suse.de
- changed neededforbuild <apache> to <apache apache-devel>
* Tue Jan 09 2001 - rolf@suse.de
- update to version 2.7.1
- use non-threadable version of python [BUG#4750]
* Mon Nov 27 2000 - rolf@suse.de
- package build
